#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

int bgmtable[19][3]={
	{0x000010 , 0x000D5380 , 0x00BF6300 },
	{0x02E77990, 0x00170A00, 0x01ADF000},
	{0x00BF6310 , 0x001D5C00, 0x016A9C00},
	{0x04956990, 0x000CB640 , 0x015E7540},
	{0x0ABF69D0, 0x00290800, 0x01AC2C00},
	{0x101722D0, 0x000A4000, 0x01459800},
	{0x05F3DFD0, 0x001D3400 , 0x01901C00 },
	{0x09437AD0 , 0x000B6300 , 0x017BEF00 },
	{0x0783FAD0 , 0x001B7000 , 0x01BF8000 },
	{0x115CBAD0 , 0x000F3000 , 0x01272220 },
	{0x0C6B95D0 , 0x002AFD00 , 0x01E11A00 },
	{0x1530F0F0 , 0x0010A500 , 0x013CBA00 },
	{0x166DAAF0 , 0x001CF700 , 0x01AEA800 },
	{0x0E4CAFD0 , 0x00268900 , 0x01CA7300 },
	{0x1283DCF0 , 0x00106C00 , 0x02AD1400 },
	{0x0229FF10 , 0x000B7900 , 0x00BD7A80 },
	{0x18A181F0 , 0x0034D680 , 0x00672F00 },
	{0x181C52F0 , 0x00061680 , 0x00852F00 },
	{0x1908B0F0 , 0x000D8E00 , 0x012EAB80 },
};

char bgmfile[19][50]={
	"ԉfˁ@` Higan Retour.wav",
	"tFa@` Colorful Path.wav",
	"IG^_[NtCg.wav",
	"tOiCg.wav",
	"dX@` Ancient Temple.wav",
	"C̓@` Invisible Full Moon.wav",
	"ĂΗ̖`.wav",
	"Hyc@` Phantom Ensemble.wav",
	"̂Ȃ@` Flower Mix.wav",
	"F܂̑f.wav",
	"_   (Short Version).wav",
	"|CY{fB@` Forsaken Doll.wav",
	"̌z@` Flower Land.wav",
	"ފ݋Aq@` Riverside View.wav",
	"Z\Nڂ̓ٔ@` Fate of Sixty Years.wav",
	"Ԃ̉f.wav",
	"ފ݂̒.wav",
	"Ԃ͌ẑ܂܂.wav",
	"̉ԁ@` Another Dream.wav",
};


void makeheader(char *header,int datasize){
	int i;
	short s;
	memcpy(header,"RIFF",4);
	i = datasize + 36;
	memcpy(header+4,&i,4);
	memcpy(header+8,"WAVEfmt ",8);
	i = 16;
	memcpy(header+16,&i,4);
	s = 1;
	memcpy(header+20,&s,2);
	s = 2;
	memcpy(header+22,&s,2);
	i = 44100;
	memcpy(header+24,&i,4);
	i = 176400;
	memcpy(header+28,&i,4);
	s = 4;
	memcpy(header+32,&s,2);
	s = 16;
	memcpy(header+34,&s,2);
	memcpy(header+36,"data",4);
	i = datasize;
	memcpy(header+40,&i,4);
	
}

int main(int argc,char *argv[]){
	FILE *datf,*bgmf;
	int i,j,l,k;
	int rep=2;
	int length;
	int fade=0;
	int fadep=0;
	int ts=0;
	int te=19;
	char header[44];
	short buf[44100*2];
	int s,e;
	double d;
	
	
	//bgmtable(JnAJԂn_܂ł̒AI_܂ł̒)Ȃ̂
	//ꂼʒuɊZ
	for(i=0;i<19;i++){
		bgmtable[i][1]+=bgmtable[i][0];
		bgmtable[i][2]+=bgmtable[i][0];
	}
		
	//argc̃`FbN
	for(i=1;i<argc;i++){
		switch(argv[i][0]){
		case 'f' :
			argv[i]++; fade=atoi(argv[i]); break;
		case 'F' :
			argv[i]++; fade=-atoi(argv[i]); break;
		case 'P' :
		case 'p' :
			argv[i]++; fadep=atoi(argv[i]); break;
		case 'T' :
		case 't' :
			argv[i]++; ts=te=atoi(argv[i]); break;
		default:
			rep=atoi(argv[i]);
		}
	}
	
	if(rep<1 || rep>10){
		printf("repeat must be 1-10\n");
		return 0;
	}
	if(fade<-30 || fade>30){
		printf("fade must be 0-30\n");
		return 0;
	}
	if(fadep<0 || fadep>3){
		printf("fade pattern must be 0-3\n");
		return 0;
	}
	if(ts<0 || te>19){
		printf("track number must be 1-19\n");
		return 0;
	}
		
	
	printf("track=%d-%d , repeat=%d , fade=%d , fade pattern=%d\n",ts,te,rep,fade,fadep);
	if(ts) ts--;
	
	datf=fopen("thbgm.dat","rb");
	if(datf==NULL){
		printf("thbgm.dat not found.");
		return 0;
	}
	
	//Jn
	for(i=ts;i<te;i++){
		
		printf("Create %s ...\n",bgmfile[i]);
		bgmf=fopen(bgmfile[i],"wb");
		length=(bgmtable[i][2]-bgmtable[i][0])+(bgmtable[i][2]-bgmtable[i][1])*(rep-1);
		if(fade<0) length+=(-fade)*44100*4;
		makeheader(header,length);
		fwrite(header,1,44,bgmf);
		
		//[v
		for(k=0;k<rep;k++){
			//[
			s=bgmtable[i][1];
			if(k==0) s=bgmtable[i][0];
			
			//I[
			e=bgmtable[i][2];
			if(k==rep-1 && fade>0) e=bgmtable[i][2]-fade*44100*4;
			
			for(j=s;j<e;j+=44100*4){
				if(j+44100*4>e) l=e-j;
				else l=44100*4;
				
				fseek(datf,j,SEEK_SET);
				fread(buf,1,l,datf);
				fwrite(buf,1,l,bgmf);
			}
		}
		
		//tF[hAEg
		if(fade>0){
			//[vI[
			s=bgmtable[i][2]-fade*44100*4;
			e=bgmtable[i][2];
		}
		else if(fade<0){
			//[v[
			s=bgmtable[i][1];
			e=s-fade*44100*4;
		}
		else{
			s=e=0;
		}
			
		for(j=s;j<e;j+=44100*4){
			if(j+44100*4>e) l=e-j;
			else l=44100*4;
			
			fseek(datf,j,SEEK_SET);
			fread(buf,1,l,datf);
			for(k=0;k<l/4;k++){
				switch (fadep) {
				case 0 :
					d=(float)((j-s)/4+k)/(abs(fade)*44100);
					d=pow(0.001,d);
					break;
				case 1 :
					d=1-(float)((j-s)/4+k)/(abs(fade)*44100);
					break;
				case 2 :
					d=(float)((j-s)/4+k)/(abs(fade)*44100);
					d=(pow(0.001,d)+(1-d))/2;
					break;
				case 3 :
					d=(cos(3.1415926535*(float)((j-s)/4+k)/(abs(fade)*44100))+1)/2;
					break;
				}
				
				buf[2*k]=(short)(buf[2*k]*d);
				buf[2*k+1]=(short)(buf[2*k+1]*d);
			}
			fwrite(buf,1,l,bgmf);
		}
		
		fclose(bgmf);
	}
	fclose(datf);
	
	return 0;
}


